<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama tombol panic" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'panic', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Tombol Panik
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="panics" ref="panicTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama Tombol Panik"
                width="300">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                align="center"
                label="Wilayah Akses"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.restricted == true" type="danger" size="mini">Dibatasi</el-tag>
                    <el-tag v-else type="success" size="mini">Terbuka</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                align="center"
                label="Total Perumahan"
                width="300"
                v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                <template slot-scope="scope">
                    <span>{{ scope.row.residentials.length }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'panic', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'panic', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch"/>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="panicForm" :model="panicForm" :rules="panicRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua tombol panic untuk masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama" prop="name">
                    <el-input ref="name" name="name" v-model="panicForm.name" placeholder="Nama tombol panik" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>  
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="panicForm.description" placeholder="Catatan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>              
                <el-row :gutter="20" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">                      
                    <el-col :lg="24" :md="24" :sm="24">
                        <el-form-item label="Untuk Perumahan" prop="residentials">
                            <el-select 
                                multiple
                                filterable
                                remote
                                reverse-keyword
                                v-model="panicForm.residentials" 
                                placeholder="Pilih perumahan" 
                                class="width-100" 
                                ref="residentials" 
                                name="residentials"
                                :remote-method="getResidentials">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">  
                                    <span style="float: left">{{ item.name }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.administrative_region[0] + ', ' + item.administrative_region[1] +', ' +item.administrative_region[2] }}</strong>                                  
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>    
                <el-form-item label="Batasi Penggunaan Tombol Panik" prop="restricted">
                    <el-checkbox v-model="panicForm.restricted">Ya, pengguna diluar batas wilayah perumahan tidak akan mendapat respon.</el-checkbox>
                </el-form-item>  
                <div v-for="(item, index) of panicForm.actions" :key="index" class="dynamic-list">
                    <el-row :gutter="20">
                        <el-col :lg="8" :md="24" :sm="24">
                            <el-form-item label="Respon Tombol Panik" :prop="item.action">
                                <el-select v-model="item.action" placeholder="Pilih respon" class="width-100" ref="action" name="action" @change="handleChangeAction(index, $event)">
                                    <el-option
                                        v-for="item in actions"
                                        :key="item.value"
                                        :label="item.label"
                                        :value="item.value">
                                    </el-option>
                                </el-select>
                            </el-form-item>
                        </el-col>
                        <el-col :lg="8" :md="24" :sm="24" v-if="item.action == 'call'">
                            <el-form-item label="No. Telp/Handphone" :prop="item.phone">
                                <el-input type="number" ref="phone" name="phone" v-model="item.phone" placeholder="No. Telp/Handphone aktif" autocomplete="off" maxlength="25"></el-input>
                            </el-form-item>
                        </el-col>
                        <el-col :lg="8" :md="24" :sm="24" v-if="item.action == 'call'">
                            <el-form-item label="No. Telp/Handphone Alternatif" :prop="item.altphone">
                                <el-input type="number" ref="altphone" name="altphone" v-model="item.altphone" placeholder="No. Telp/Handphone aktif" autocomplete="off" maxlength="25"></el-input>
                            </el-form-item>
                        </el-col>
                        <el-col :lg="16" :md="24" :sm="24" v-if="['alarm', 'notification'].indexOf(item.action) > -1">
                            <el-form-item label="Role" :prop="item.role.toString()">
                                <el-select
                                    ref="role"
                                    name="role"
                                    class="width-100"
                                    v-model="item.role"
                                    value-key="id"
                                    placeholder="Pilih Role"
                                    no-data-text="No Data">
                                    <el-option
                                        v-for="role in userRoles"
                                        :key="role.id"
                                        :label="role.name"
                                        :value="role.id">                        
                                    </el-option>
                                </el-select>
                            </el-form-item>
                        </el-col>
                    </el-row>
                    
                    <el-form-item>
                        <el-button class="float-right margin-small-left" @click="deleteAction(index)" v-if="index > 0" icon="el-icon-delete" type="danger" size="mini">Hapus</el-button>
                        <el-button class="float-right" @click="addAction" v-if="(index + 1) == panicForm.actions.length" icon="el-icon-plus" type="success" size="mini"> Tambah</el-button>
                    </el-form-item>
                </div>        
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'panic', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Panic',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            tableLoading: false,
            dialogLoading: false,
            filter: {
                keyword: '',
                residential: null          
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Tombol Panik',
                create: 'Tambah Tombol Panik'
            },
            actions: [{
                label: 'Call',
                value: 'call'
            }, {
                label: 'Alarm',
                value: 'alarm'
            }, {
                label: 'Notification',
                value: 'notification'
            }],
            panicForm: {
                id: null,
                name: null,
                icon: null,
                restricted: false,
                description: '',
                residentials: [],
                actions: [{
                    action: null,
                    phone: '',
                    altphone: '',
                    role: '',
                    residential: ''
                }],
                archived: false
            },
            panicRules: {
                name: [{ 
                    required: true, message: 'Nama tombol panik wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama tombol panik maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                description: [{
                    max: 255, message: 'Deskripsi maksimal 255 karakter', trigger: 'blur'
                }]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('role', ['roles']),
        ...mapGetters('user', ['me']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('panic', [
            'panics',
            'pagination'
        ]),
        userRoles: function(){
            if(this.me.role.slug === 'root'){
                return this.roles;
            }else{
                return this.roles.filter((x) => ['orphan', 'root', 'owner'].indexOf(x.slug) === -1);
            }
        }
    },
    created() {
        this.getPanics();
        this.getResidentials();
        this.getRoles();
    },
    methods: {
        playSound,
        dateFormat,
        getPanics() {
            this.tableLoading = true;
            this.$store.dispatch('panic/getPanics', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;                
            });
        },
        getRoles() {
            this.tableLoading = true;
            this.$store.dispatch('role/getAllRoles', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            this.tableLoading = true;
            this.$store.dispatch('panic/getPanics', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['panicForm'].clearValidate();
            });
        },
        handleEdit(panic){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.panicForm.id = panic.id;
            this.panicForm.name = panic.name;
            this.panicForm.icon = panic.icon;
            this.panicForm.restricted = panic.restricted;
            this.panicForm.description = panic.description;            
            this.panicForm.archived = panic.archived;

            if(panic.actions.length > 0){
                this.panicForm.actions = [];
                for(const x of panic.actions){
                    this.panicForm.actions.push({
                        action: x.action,
                        phone: x.phone,
                        altphone: x.alt_phone,
                        role: x.role ? x.role.id : ''
                    });
                }
            }

            this.panicForm.residentials = panic.residentials.map((x) => x.id);

            if(panic.residentials.length){
                this.getResidentials();
            }

            this.$nextTick(() => {
                this.$refs['panicForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.panicForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'panic/addPanic';
                        payload = {
                            name: this.panicForm.name,
                            icon: this.panicForm.icon,
                            restricted: this.panicForm.restricted,
                            description: this.panicForm.description,
                            residentials: this.panicForm.residentials,
                            actions: this.panicForm.actions
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'panic/editPanic';
                        payload = {
                            id: this.panicForm.id,
                            name: this.panicForm.name,
                            icon: this.panicForm.icon,
                            restricted: this.panicForm.restricted,
                            description: this.panicForm.description,
                            residentials: this.panicForm.residentials,
                            actions: this.panicForm.actions,
                            archived: this.panicForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(panic){
            this.$confirm('Anda mencoba untuk menghapus data tombol panik, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('panic/deletePanic', {
                    id: panic.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        handleChangeAction(index, value){
            if(value == 'call'){
                Object.assign(this.panicForm.actions[index], {
                    role: '',
                    user: '',
                    notifto: ''
                });
            }else if( value == 'alarm'){
                Object.assign(this.panicForm.actions[index], {
                    phone: '',
                    altphone: '',
                    user: '',
                    notifto: ''
                });
            }else if( value == 'notification'){
                Object.assign(this.panicForm.actions[index], {
                    phone: '',
                    altphone: '',
                    role: '',
                    user: ''
                });
            }
        },
        resetForm() {
            this.panicForm = {
                id: null,
                name: null,
                icon: '',
                restricted: false,
                description: '',
                residentials: [],
                actions: [{
                    action: null,
                    phone: '',
                    altphone: '',
                    role: '',
                    user: '',
                    notifto: ''
                }],
                archived: false
            };
        },
        addAction() {
            this.panicForm.actions.push({
                action: '',
                phone: '',
                altphone: '',
                role: '',
                user: '',
                notifto: ''
            });
        },
        deleteAction(index) {
            for(const [i, v] of this.panicForm.actions.entries()){
                if(i == index){
                    this.panicForm.actions.splice(i, 1);                    
                    break;
                }
            }
        }
    }

}
</script>